#!/bin/bash
#
#
# DO NOT EDIT THIS SCRIPT TO UPDATE CONTENT!!!
#
# Content is updated by contributors via 4 files for EACH entry:
#
# manu_desc_info.txt
# manu_desc_source.txt
# manu_desc_graphic.jpg  (320 x 240 black and white JPEG)
# manu_desc_photo.jpg    (320 x 240 full color JPEG)
#
# "manu_desc" portion MUST BE EXACTLY THE SAME FOR ALL 4 FILES!!!
#
# All filenames must be free of spaces and must be all lower-case!!!
#
#
# This script when run will load them along with the old contributed files
# and generate a new HTML page reflecting the new entry.
#
#
# When it appears that all is well and accurate after running the script,
# running the script "cleanup.sh" will clean out .tmp and ~ files.
#
#
#
# SECTIONS
#
# Delete previously generated HTML page to make way for new page.
# Setup overall theme and layout of the page.  Create HTML title, 
# header, timestamp, table and table column titles, etc. 

cat /dev/null > main.html
echo "<html>" >> main.html
echo "<head><title>Spoke Head Identification Chart</title></head>" >> main.html
echo "<body bgcolor="#ffffff">" >> main.html
echo "<center>" >> main.html
echo "<h1>Spoke Head Identification Chart</h1>" >> main.html
echo "<b>Project Genesis: <i>John Hurley</i></b>" >> main.html
echo "<br>" >> main.html
echo "<b>Content Maintenance: <i>John Hurley & Robert Shackelford</i></b>" >> main.html
echo "<br>" >> main.html
echo "<b>Design & Scripting: <i>Robert Shackelford</i></b>" >> main.html
echo "<br>" >> main.html
echo "<br>" >> main.html
lastedit=`date +%c`
echo "<i>Last Updated: $lastedit </i>" >> main.html
echo "<br>" >> main.html
echo "<br>" >> main.html
echo "</center>" >> main.html
echo "<a href="./about.html" target="_blank">About |</a><a href="./contribute.html" target="_blank"> Contribute</a>" >> main.html
echo "<br>" >> main.html
echo "<center>" >> main.html
echo "<table border="1" valign="top" cellpadding="10%">" >> main.html
echo "<tr>" >> main.html
echo "<td><center><b>Spoke Information & Description</b></center></td><td><center><b>Source Reference</b></center></td><td><center><b>Graphical Representation</b></center></td><td><center><b>Photographic Sample</b></center></td>" >> main.html
echo "</tr>" >> main.html


# Pipe listing of source files as filenames into temporary work files.

ls *_info.txt > info.tmp
ls *_source.txt > source.tmp
ls *_graphic.jpg > graphic.tmp
ls *_photo.jpg > photo.tmp


# Filter and set whitespaces attributes of the temporary work files
# while dumping into undeclared arrays.  Whitespace conditioning
# ensures that each filename is a separate array item.

info=( `cat info.tmp | tr '\n' ' '`)
source=( `cat source.tmp | tr '\n' ' '`)
graphic=( `cat graphic.tmp | tr '\n' ' '`)
photo=( `cat photo.tmp | tr '\n' ' '`)


# Go ahead and count the number of items in each array even though
# we will only use the first for array indexing  purposes.

info_count=${#info[@]}
source_count=${#source[@]}
graphic_count=${#graphic[@]}
photo_count=${#photo[@]}


# For debugging purposes, create "array_contents.txt" to verify
# the contents of the arrays and that array items are getting
# counted correctly for indexing purposes.

echo ${info[@]} > array_contents.txt
echo ${#info[@]} >> array_contents.txt


# Declare variable $index for the "while" test that follows

index=0


# Empty and HTML format the array data until we've reached
# the end of the data in each array

while [ "$index" -lt "$info_count" ]
do
   echo "<tr>" >> main.html
   info_text=`cat ${info[$index]}`
   source_text=`cat ${source[$index]}`
   echo "<td> $info_text </td><td> $source_text </td><td><img src="./${graphic[$index]}"></td><td><img src="./${photo[$index]}"></td>" >> main.html
   echo "</tr>" >> main.html
   let "index = $index + 1"
done


# Close the table, kill centering, close the body, close the html
# and get her done!

echo "</table>" >> main.html
echo "</center>" >> main.html
echo "</body>" >> main.html
echo "</html>" >> main.html

